#!/usr/bin/env python

# See: https://answers.atlassian.com/questions/87971/what-is-the-algorithm-used-to-create-the-tiny-links

from base64 import b64decode, b64encode
from struct import pack, unpack
import sys

def tiny_url(s):
    return b64encode(pack("<I", int(s)).rstrip("\x00")).rstrip("=").replace("+", "_").replace("/", "-")

def identifier(s):
    bytes = b64decode(s.replace("-", "/").replace("_", "+") + "=" * (6 - len(s)))
    return unpack("<I", bytes + "\x00" * (4 - len(bytes)))[0]

arg = sys.argv[1]
reverse = len(sys.argv) > 2 and sys.argv[2] in ("-r", "--reverse")
fn = reverse and identifier or tiny_url

if arg == "-":
    for line in sys.stdin.readlines():
        line = line.strip()
        if line:
            print "%s\t%s" % (fn(line), line)
else:
    print fn(arg)

# vim: tabstop=4 expandtab shiftwidth=4
